<?php
/*
 * Plugin Name: Clipsan Video 
 * Plugin URI: https://help.clipsan.com/wordpress-plugin/
 * Description: This plug-in displays list of Clipsan videos. 
 * This also enable you to watch these videos.
 * Version: 1.0 
 * Author: Clipsan Author 
 * URI: https://clipsan.com/
 */

require_once 'clipsan.inc';
require_once 'video.php';

// init clipsan instance
clipsan::getInstance ();

add_shortcode ( 'clip', array (clipsan_video::getInstance(), 'view') );
add_shortcode ( 'clip_download', array(clipsan_video::getInstance(), 'download') );
add_shortcode ( 'clip_download_op', array(clipsan_video::getInstance(), 'downloadOp') );
add_shortcode ( 'clip_audio', array(clipsan_video::getInstance(), 'audio') );

add_shortcode ( 'clip_listing', array (
		clipsan::getInstance (),
		'listing' 
) );
add_filter ( 'the_content', array (
		clipsan::getInstance (),
		'fixparagraph' 
) );



add_action ( 'init', 'clipsanStartSession', 1 );
add_action ( 'wp_logout', 'clipsanEndSession' );
add_action ( 'wp_login', 'clipsanEndSession' );

function clipsanStartSession() {
	if (! session_id ()) {
		session_start ();
	}
	if ($_REQUEST['clp_lead_key'] && preg_match('/^([a-zA-Z0-9]*)$/', $_REQUEST['clp_lead_key']))
	{
		setcookie("clipsan_lead", $_REQUEST['clp_lead_key'], time() + 86400 * 365);
		$_COOKIE['clipsan_lead'] = $_REQUEST['clp_lead_key'];
	}
}

function clipsanEndSession() {
	session_destroy ();
}

function clipsan_expire_visiters_addon($date, $campaign_id, $third, $info)
{
	list($day,$hrs,$mins,$secs) = $date;
	
	$lead = $_COOKIE['clipsan_lead'];
	if ($lead && preg_match('/^([a-zA-Z0-9]*)$/', $lead) && get_option('clipsan_securekey') && get_option('clipsan_per_'.$campaign_id))
	{
		// get funnel stage id
		$funnel_stage_id = get_option('clipsan_per_'.$campaign_id);
		$open_window = $info['day'] * 24 * 3600 + $info['hrs'] * 3600 + $info['mins'] * 60 + $info['secs'];
		$expire = $day * 24 * 3600 + $hrs * 3600 + $mins * 60 + $secs;
		
		// read starting message from clipsan
		$url = 'https://clipsan.com/api/mail/view/?key='.get_option('clipsan_securekey').'&lead='.urlencode($lead).'&stage='.$funnel_stage_id;
		$curl = curl_init($url);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		$json = curl_exec($curl);
		curl_close($curl);
		$response = json_decode($json);
		if ($response->result != 'ok' || $response->count == 0)
		{
			return array($day,$hrs,$mins,$secs);
		}
		foreach ($response->mails as $mail)
		{
			$clipsan_expire = $mail->sent + $open_window - time();
			break;
		}

		// if diff to local time then update cookie
		if (abs($clipsan_expire - $expire) > 3600)
		{
			$day = floor($clipsan_expire / (24 * 3600));
			$tmp_expire = $clipsan_expire - $day * 24 * 3600;
			$hrs = floor($tmp_expire / 3600);
			$tmp_expire = $tmp_expire - $hrs * 3600;
			$mins = floor($tmp_expire / 60);
			$secs = $tmp_expire % 60;
			$mtr = time() + $clipsan_expire - $open_window;
			setcookie("expirer_timestamp_".$campaign_id, $mtr,time()+(86400*365));
		}
	}
	return array($day,$hrs,$mins,$secs);
}

add_filter('per_expire_visiters_addon', 'clipsan_expire_visiters_addon', 10, 4);