<?php
/**
 * Clipsan plugin class
 *
 * @author CIWire
 */
class clipsan_video
{

	/**
	 *
	 * @var string
	 */
	protected $server;

	/**
	 * Default constructor
	 */
	function __construct()
	{
		$this->server = 'https://clipsan.com';
	}

	/**
	 * Get instance
	 *
	 * @return clipsan
	 */
	function &getInstance()
	{
		static $instance = null;
		
		if (!isset($instance))
		{
			$instance = new clipsan_video();
		}
		
		return $instance;
	}

	protected function instantView($lang, $hash, $width, $height, $autoplay = 0, $type = null)
	{
		global $current_user;
		get_currentuserinfo();
		
		if (preg_match('/(iPhone|iPod|iPad|android|Linux zbov)/', $_SERVER['HTTP_USER_AGENT']))
		{
			return false;
		}
		
		// fetch xml
		$url = "{$this->server}/$lang/player/hash/$hash/width/$width/height/$height/time/" . time() . "/autoplay/" . intval($autoplay) . "/ip/" . $_SERVER['REMOTE_ADDR'];
		if ($current_user->user_email)
		{
			$url .= '/custom/' . $current_user->user_email;
		}
		if ($type)
		{
			$url .= '/type/' . $type;
		}
		$url .= "?location=" . urlencode($this->getCurrentUrl());
		$url .= "&HTTP_USER_AGENT=" . urlencode($_SERVER['HTTP_USER_AGENT']);
		$json = @file_get_contents($url);
		$array = json_decode(substr($json, 1, strlen($json) - 2), true);
		
		if (is_array($array) && key_exists('html', $array))
		{
			return '<script type="text/javascript" src="//static.clipsan.com/js/jwplayer.js"></script><div class="clipsan-player">' . $array['html'] . '</div>';
		}
		return false;
	}
	
	public function download($atts) {
		global $current_user;
	
		extract ( shortcode_atts ( array (
		'hash' => '',
		), $atts ) );
	
		if (! $current_user->ID) {
			return '#';
		}
	
		return site_url ( '/wp-content/plugins/clipsan-video/download.php?hash=' . $hash );
	}
	
	public function downloadOp($atts) {
	
		extract ( shortcode_atts ( array (
		'title' => get_the_title(),
		), $atts ) );
	
		$url = $this->download($atts);
	
		return '<ul class="downloadlist-1 border"><li><a target="_blank" href="'.$url.'"><img src="'.site_url('/wp-content/themes/optimizePressTheme/lib/assets/images/file_download/icons/style1-Mov-64x64.png').'" alt="icon" class="thumb"/></a><div class="content"><a target="_blank" href="'.$url.'">'.$title.'</a><p>Video ke stažení</p></div></li></ul>';
	}
	
	public function audio($atts) {
		global $current_user;
	
		extract ( shortcode_atts ( array (
		'hash' => '',
		), $atts ) );
	
		if (! $current_user->ID) {
			return '#';
		}
	
		return site_url ( '/wp-content/plugins/clipsan-video/download.php?type=mp3&amp;hash=' . $hash );
	}

	protected function getCurrentUrl($query = '')
	{
		$query = $query ? (strpos($_SERVER['REQUEST_URI'], '?') !== false ? '&' . $query : '?' . $query) : '';
		return ($_SERVER['SERVER_PORT'] == 80 ? 'http://' : 'https://') . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'] . $query;
	}

	protected function readVideo($hash)
	{
		$url = "{$this->server}/api/clip/clipsan/?hash=$hash&key=" . get_option('clipsan_securekey')."&ip=".$_SERVER['REMOTE_ADDR'];
		$json = file_get_contents($url);
		return json_decode($json, true);
	}

	public function view($atts)
	{
		global $current_user;
		get_currentuserinfo();
		
		extract(shortcode_atts(array(
			'hash' => '', 
			'lang' => '', 
			'width' => '', 
			'height' => '', 
			'scale' => '1', 
			'read' => '0', 
			'instant' => '0', 
			'audio' => '0', 
			'flv' => '0', 
			'secure' => '0', 
			'limit' => '0', 
			'autoplay' => ''), $atts));
		
		if (get_option('clipsan_readall'))
		{
			$read = true;
		}
		if (get_option('clipsan_secureall') || $limit)
		{
			$secure = true;
		}
		if (get_option('clipsan_limitedplay'))
		{
			$limit = true;
		}
		
		if (!$current_user->ID && $secure)
		{
			return 'Video je pouze pro přihlášené uživatele';
		}
		
		$add = '';
		if ($read && is_array($array = $this->readVideo($hash)))
		{
			$html5 = key_exists('html5', $array) ? $array['html5'] : false;
			if (key_exists('unique', $array))
			{
				$add .= ' data-unique="' . $array['unique'] . '"';
			}
			$clip_audio = key_exists('audio', $array) ? $array['audio'] : false;
			$clip_flv = key_exists('flv', $array) ? $array['flv'] : false;
			if (!$width)
			{
				$width = key_exists('width', $array) ? $array['width'] : 480;
			}
			if (!$height)
			{
				$height = key_exists('height', $array) ? ceil($width / $array['width'] * $array['height']) : 360;
			}
			$lang = !$lang && key_exists('en', $array) ? 'en' : 'cs';
		}
		else
		{
			$html5 = false;
			$width = $width ?  : 480;
			$height = $height ?  : 360;
			$lang = 'cs';
		}
		
		if ($atts['cbwidth'] && $atts['cbheight'])
		{
			$add .= ' data-colorbox="1" data-cb-width="' . $atts['cbwidth'] . '" data-cb-height="' . $atts['cbheight'] . '"';
		}
		elseif ($instant || $autoplay)
		{
			
			if ($limit)
			{
				$security = $this->secureVideo($hash);
				if ($security)
				{
					return $security;
				}
			}
			$instant = $this->instantView($lang, $hash, $width, $height, $autoplay, $html5 ? 'html5' : '');
			if ($instant)
			{
				return $instant . $append;
			}
		}
		
		if (isset($clip_audio) && $clip_audio && $audio)
		{
			$append = '<a href="http://video.cdn1.clipsan.com/' . $hash . '-0.mp3">Stáhnout audio stopu jako soubor MP3</a>';
		}
		
		wp_enqueue_script('clipsan', "//static.clipsan.com/js/player5.js", array(
			'jquery'));
		return '<div class="clipsan-player"' . $add . ' data-movie="' . $hash . '" data-width="' . $width . '" data-height="' . $height . '" data-lang="' . $lang . '" ' . ($scale ? 'data-scale="1" ' : '') . ($autoplay ? 'data-autoplay="1" ' : '') . 'data-custom="' . $current_user->user_email . '" ></div>' . $append;
	}

	protected function secureVideo($hash)
	{
		global $wpdb;
		global $current_user;
		get_currentuserinfo();
		
		if (isset($_SESSION['clipsan-video']) && key_exists($hash, $_SESSION['clipsan-video']))
		{
			return false;
		}
		
		$data = array(
			'hash' => $hash, 
			'ip' => $_SERVER['REMOTE_ADDR'], 
			'email' => $current_user->user_email, 
			'added' => date('Y-m-d H:i:s'));
		
		$plays = $wpdb->get_results($wpdb->prepare('SELECT ip, COUNT(*) AS playcount FROM ' . clipsan::getInstance()->getPlayTableName() . " WHERE hash = '$hash' AND email = '{$current_user->user_email}' AND added > NOW() - INTERVAL 24 HOUR GROUP BY ip"));
		foreach ($plays as $play)
		{
			if ($play->ip != $_SERVER['REMOTE_ADDR'] || $play->playcount > 2)
			{
				$security = $this->secureForm($hash);
				if ($security)
				{
					return $security;
				}
			}
		}
		$wpdb->insert(clipsan::getInstance()->getPlayTableName(), $data);
		$_SESSION['clipsan-video'][$hash] = true;
		return false;
	}

	protected function secureForm($hash)
	{
		global $wpdb;
		global $current_user;
		get_currentuserinfo();
		
		$passwords = $wpdb->get_results($wpdb->prepare('SELECT password FROM ' . clipsan::getInstance()->getPassTableName() . " WHERE email = '{$current_user->user_email}' ORDER BY added DESC LIMIT 1"));
		foreach ($passwords as $password)
		{
			if ($_REQUEST['password'] == $password->password)
			{
				return false;
			}
		}
		
		if (!isset($password) || $_REQUEST['generate'])
		{
			$password = substr(md5(rand() . microtime(true)), 0, 6);
			
			$body = ('Dobrý den,') . "\n\n";
			$body .= sprintf(('Video "%s" bylo několikrát přehráno z různých počítačů.'), trim(get_the_title())) . "\n";
			$body .= ('Pro zajištění Vašeho soukromí a přehrání videa je nutné zadat Vaše osobní heslo.') . "\n\n";
			$body .= sprintf(('Vaše osobní heslo zní: %s'), $password) . "\n\n";
			$body .= sprintf(('Zadejte heslo na stránce: %s'), $this->getCurrentUrl()) . "\n\n";
			$body .= ('Heslo si uchovejte pro pozdější použití.') . "\n\n";
			$body .= ('Užijte si video') . "\n" . get_bloginfo('name', 'display');
			
			wp_mail($current_user->user_email, 'Vaše osobní heslo', $body);
			
			$data = array(
				'hash' => $hash, 
				'password' => $password, 
				'email' => $current_user->user_email, 
				'added' => date('Y-m-d H:i:s'));
			$wpdb->insert(clipsan::getInstance()->getPassTableName(), $data);
			$message = '<div style="color: #c00"><strong>Nové heslo bylo zasláno na Váš email ' . $current_user->user_email . '.</strong></div>';
		}
		elseif ($_REQUEST['password'])
		{
			$message = '<div style="color: #c00"><strong>Neplatné heslo</strong></div>';
		}
		
		$form = '<h4>Video bylo několikrát přehráno z různých počítačů.</h4>
		<p>Pro zajištění Vašeho soukromí a přehrání videa je nutné zadat Vaše osobní heslo.</p>
		<h3>Zadejte Vaše osobní heslo prosím</h3>
		' . $message . '
		<form action="" method="post">
			<label for="password">Vaše heslo</label>
			<input type="text" name="password" placeholder="Zadejte Vaše osobní heslo" required="required" /><br />
			<input type="hidden" name="clipsan_pass_submit" value="1" />
			<input type="hidden" name="generate" value="0" />
			<input type="submit" value="Spustit video" />
		</form><br />
		<p>
			Zapoměl(a) jste heslo?<br />
			<a href="' . $this->getCurrentUrl('generate=1') . '">Klikněte zde a zašleme Vám nové heslo na Vaši emailovou adresu.</a><br />
			PS: Staré heslo již nebude platné.
		</p>';
		
		return $form;
	}
}